> ## Documentation Index
> Fetch the complete documentation index at: https://synapse-docs.apart.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Upsert Subject



## OpenAPI

````yaml /openapi.json post /v1/organizations/{organization_id}/apps/{app_id}/environments/{environment_id}/subjects
openapi: 3.1.0
info:
  description: Are we on the same page?
  title: Synapse
  version: 0.1.0
servers: []
security: []
paths:
  /v1/organizations/{organization_id}/apps/{app_id}/environments/{environment_id}/subjects:
    post:
      tags:
        - v1 control plane
      summary: Upsert Subject
      operationId: >-
        upsert_subject_v1_organizations__organization_id__apps__app_id__environments__environment_id__subjects_post
      parameters:
        - in: header
          name: Idempotency-Key
          required: true
          schema:
            maxLength: 255
            minLength: 1
            title: Idempotency-Key
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SubjectUpsertRequest'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SubjectUpsertResponse'
          description: Successful Response
        '422':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
          description: Validation Error
      security:
        - BearerAuth: []
        - ApiKeyAuth: []
        - SessionCookie: []
components:
  schemas:
    SubjectUpsertRequest:
      additionalProperties: false
      properties:
        external_id:
          maxLength: 512
          minLength: 1
          title: External Id
          type: string
        identity_mode:
          const: enterprise_managed
          default: enterprise_managed
          title: Identity Mode
          type: string
        profile:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Profile
      required:
        - external_id
      title: SubjectUpsertRequest
      type: object
    SubjectUpsertResponse:
      properties:
        created:
          title: Created
          type: boolean
        idempotent_replay:
          default: false
          title: Idempotent Replay
          type: boolean
        subject:
          $ref: '#/components/schemas/SubjectSummary'
      required:
        - subject
        - created
      title: SubjectUpsertResponse
      type: object
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          title: Detail
          type: array
      title: HTTPValidationError
      type: object
    SubjectSummary:
      properties:
        app_id:
          title: App Id
          type: string
        created_at:
          format: date-time
          title: Created At
          type: string
        environment_id:
          title: Environment Id
          type: string
        id:
          title: Id
          type: string
        identity_mode:
          enum:
            - enterprise_managed
            - reusable
            - legacy_anonymous
          title: Identity Mode
          type: string
        organization_id:
          title: Organization Id
          type: string
        status:
          enum:
            - active
            - deleted
          title: Status
          type: string
        updated_at:
          format: date-time
          title: Updated At
          type: string
      required:
        - id
        - organization_id
        - app_id
        - environment_id
        - identity_mode
        - status
        - created_at
        - updated_at
      title: SubjectSummary
      type: object
    ValidationError:
      properties:
        ctx:
          title: Context
          type: object
        input:
          title: Input
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          title: Location
          type: array
        msg:
          title: Message
          type: string
        type:
          title: Error Type
          type: string
      required:
        - loc
        - msg
        - type
      title: ValidationError
      type: object
  securitySchemes:
    BearerAuth:
      description: Named syn_ API key or migration-only legacy key.
      scheme: bearer
      type: http
    ApiKeyAuth:
      description: Header alias for a named or legacy API key.
      in: header
      name: X-API-Key
      type: apiKey
    SessionCookie:
      description: Opaque administrator browser session.
      in: cookie
      name: synapse_session
      type: apiKey

````